<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:c="http://java.sun.com/jstl/core"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns="http://www.w3.org/1999/xhtml"
                template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <s:div id="globalDiv"><h1>#{procedureSender.selectedDomain.name}
                #{procedureSender.simulatedActor.name}</h1>
                <gri:panel pid="globalPanel">
                    <f:facet name="header">
                        <s:div>
                            <h:outputText value="#{messages['gazelle.ordermanager.ScheduleAndUpdateProcedure']}"/>
                        </s:div>
                    </f:facet><!-- SUT Selection -->
                    <s:div styleClass="gzl-alert gzl-alert-blue" rendered="#{procedureSender.selectedDomain.keyword == 'RAD'}">
                        <ui:decorate template="/layout/form/_checkbox.xhtml">
                            <h:selectBooleanCheckbox value="#{userPreferencesManagerBean.hl7v251Option}">
                                <a4j:ajax event="change" render="messageConfigurationDiv"/>
                            </h:selectBooleanCheckbox>
                            #{messages['gazelle.ordermanager.SendHL7v251Messages']}
                        </ui:decorate>
                        <span class="gzl-icon-info-circle"/>
                        <h:outputText
                                value="#{messages['gazelle.ordermanager.CheckingThisBoxWillAskTheToolToSendMessagesCompl']}"/>
                    </s:div>
                    <ui:include src="/configuration/initiatorFrame.xhtml">
                        <ui:param name="diagramImg" value="#{procedureSender.sequenceDiagramPath}"/>
                        <ui:param name="currentConfig" value="#{userPreferencesManagerBean.selectedSUT}"/>
                        <ui:param name="simuFacility" value="#{procedureSender.sendingFacility}"/>
                        <ui:param name="simuApplication" value="#{procedureSender.sendingApplication}"/>
                        <ui:param name="sectionsToReRender"
                                  value="sendMessageButtonDiv"/>
                        <ui:param name="simulatorConfigurationName"
                                  value="#{procedureSender.selectedDomain.name} #{procedureSender.simulatedActor.name}"/>
                        <ui:param name="availableSuts" value="#{procedureSender.getAvailableSUTs()}"/>
                    </ui:include>
                    <br/><!-- Action selection -->
                    <s:div id="availableActionsDiv" rendered="#{procedureSender.hl7Messages == null}">
                        <div class="form-horizontal">
                            <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                <ui:define name="label">#{messages['gazelle.ordermanager.ActionToPerform']}</ui:define>
                                <ui:param name="id" value="action"/>
                                <h:selectOneMenu value="#{procedureSender.orderControlCode}" id="action"
                                                 styleClass="form-control">
                                    <f:selectItems value="#{procedureSender.listAvailableActions()}"/>
                                    <a4j:ajax event="change" render="availableActionsDiv, selectionDiv"
                                              listener="#{procedureSender.onChangeActionEvent()}"/>
                                </h:selectOneMenu>
                            </s:decorate>
                        </div>
                    </s:div>
                    <br/>
                    <s:div id="selectionDiv"
                           rendered="#{procedureSender.hl7Messages == null}"><!-- Schedule procedure Div -->
                        <s:div id="newOrderDiv"
                               rendered="#{procedureSender.orderControlCode.equals(procedureSender.SCHEDULE)}">
                            <gri:panel pid="orderSelectionPanel"
                                       rendered="#{procedureSender.selectionType == 'ORDER' and procedureSender.selectedEncounter == null}">
                                <f:facet name ="header">
                                    #{messages['gazelle.ordermanager.Selection']}
                                </f:facet>
                                <h:outputText
                                        value="#{messages['gazelle.ordermanager.SelectAnOrderForWhichYouWantToScheduleAProcedure']} #{messages['gazelle.ordermanager.OrCreateANewOneFromScratch']}"
                                        styleClass="help-block"/>
                                <a4j:commandButton value="#{messages['gazelle.ordermanager.NewOrder']}" actionListener="#{procedureSender.displayEncounterList()}"
                                                 render="selectionDiv"
                                                 styleClass="gzl-btn-blue"/>
                                <br/><br/>
                                <!-- filters -->
                                <f:subview id="orderFilterView">
                                    <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                                        <ui:define name="filter_buttons">
                                            <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                             render="orderSelectionPanel">
                                                <span class="gzl-icon-refresh"/>
                                            </a4j:commandLink>
                                            <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                             actionListener="#{procedureSender.orderFilter.reset()}"
                                                             render="orderSelectionPanel">
                                                <span class="gzl-icon-times-circle"/>
                                            </a4j:commandLink>
                                        </ui:define>
                                        <ui:include src="/common/filtersOnOrder.xhtml">
                                            <ui:param name="filterClass" value="#{procedureSender.orderFilter}"/>
                                            <ui:param name="formId" value="orderSelectionPanel"/>
                                        </ui:include>
                                    </ui:decorate>
                                </f:subview>
                                <br/><br/>
                                #{dataTableStateHolder.setDescendingOn('lastChanged')}
                                <rich:dataTable value="#{procedureSender.orderFilter.getOrders()}" var="orderVar"
                                                rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                                id="orders1Table"
                                                render="ds">
                                    <ui:include src="/common/orderColumns.xhtml">
                                        <ui:param name="managedBean" value="#{procedureSender}"/>
                                        <ui:param name="currentOrder" value="#{orderVar}"/>
                                        <ui:param name="displayEncounterInfo" value="true"/>
                                    </ui:include>
                                    <g:column id="orderActionColumn">
                                        <ui:define name="header">#{messages['users.Action']}</ui:define>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.Select']}"
                                                         actionListener="#{procedureSender.scheduleProcedureForSelectedOrder(orderVar)}"
                                                         rendered="#{empty orderVar.requestedProcedures}"
                                                         render="newOrderDiv">
                                            <span class="gzl-icon-calendar-o"/>
                                        </a4j:commandLink>
                                        <h:outputText value="#{messages['gazelle.ordermanager.AlreadyScheduled']}"
                                                      rendered="#{not empty orderVar.requestedProcedures}"/>
                                    </g:column>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="ds"/>
                                            <ui:param name="dataTableId" value="orders1Table"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </gri:panel><!-- select an encounter rather than create a procedure from existing order -->
                            <gri:panel pid="encounterSelectionPanel"
                                       rendered="#{procedureSender.selectedEncounter == null and  not (procedureSender.selectionType == 'ORDER' or procedureSender.selectionType == 'PROCEDURE')}">
                                <f:facet name="header">#{messages['gazelle.ordermanager.EncounterSelection']}</f:facet>
                                <a4j:commandLink actionListener="#{procedureSender.displayOrderList()}"
                                                 render="newOrderDiv" styleClass="gzl-btn-orange">
                                    <h:outputText
                                            value="#{messages['gazelle.ordermanager.BackToOrderSelection']}"/>
                                </a4j:commandLink>
                                <a4j:commandLink actionListener="#{procedureSender.displayEncounterList()}"
                                                 styleClass="gzl-btn-blue"
                                                 render="newOrderDiv"
                                                 rendered="#{procedureSender.selectionType != 'ENCOUNTER'}">
                                    <h:outputText
                                            value="#{messages['gazelle.ordermanager.ExistingEncounters']}"/>
                                </a4j:commandLink>
                                <a4j:commandLink actionListener="#{procedureSender.displayAvailableCountries()}"
                                                 styleClass="gzl-btn-blue"
                                                 render="newOrderDiv"
                                                 rendered="#{procedureSender.selectionType != 'DDS'}">
                                    <h:outputText
                                            value="#{messages['gazelle.ordermanager.NewPatient']}"/>
                                </a4j:commandLink>
                                <a4j:commandLink actionListener="#{procedureSender.displayPatientsList()}"
                                                 styleClass="gzl-btn-blue"
                                                 render="newOrderDiv"
                                                 rendered="#{procedureSender.selectionType != 'PATIENT'}">
                                    <h:outputText
                                            value="#{messages['gazelle.ordermanager.ExistingPatients']}"/>
                                </a4j:commandLink>
                                <br/>
                                <br/><!-- Generate a new patient -->
                                <gri:panel rendered="#{procedureSender.selectionType == 'DDS'}">
                                    <f:facet name="header">
                                        #{messages['gazelle.ordermanager.ChooseACountryForTheGeneratedPatient']}
                                    </f:facet>
                                    <ui:include src="/patient/patientGenerator.xhtml">
                                        <ui:param name="patientGeneratorBean" value="#{procedureSender}"/>
                                        <ui:param name="displayAllCriteria" value="true"/>
                                        <ui:param name="ddsEndpoint"
                                                  value="#{applicationConfiguration.getValueOfVariable('dds_ws_endpoint')}"/>
                                    </ui:include>
                                    <a4j:commandButton id="generateButton"
                                                       value="#{messages['gazelle.ordermanager.Generate']}"
                                                       actionListener="#{procedureSender.createNewPatientAndEncounter()}"
                                                       styleClass="gzl-btn-blue" render="newOrderDiv"/>
                                    <a4j:commandButton value="#{messages['users.Cancel']}"
                                                       actionListener="#{procedureSender.cancelPatientCreation()}"
                                                       styleClass="gzl-btn-orange" render="newOrderDiv"/>
                                </gri:panel>
                                <br/>
                                <!-- Select an existing encounter -->
                                <s:div id="encounterSelection"
                                       rendered="#{procedureSender.selectionType == 'ENCOUNTER'}">
                                    <f:subview id="encFilterView">
                                        <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                                            <ui:define name="filter_buttons">
                                                <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                                 render="encounterSelection">
                                                    <span class="gzl-icon-refresh"/>
                                                </a4j:commandLink>
                                                <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                                 actionListener="#{procedureSender.encounterFilter.reset()}"
                                                                 render="encounterSelection">
                                                    <span class="gzl-icon-times-circle"/>
                                                </a4j:commandLink>
                                            </ui:define>
                                            <ui:include src="/common/filtersOnEncounter.xhtml">
                                                <ui:param name="formId" value="encounterSelection"/>
                                                <ui:param name="filterClass"
                                                          value="#{procedureSender.encounterFilter}"/>
                                            </ui:include>
                                        </ui:decorate>
                                    </f:subview>
                                    #{dataTableStateHolder.setDescendingOn('creationDate')}
                                    <rich:dataTable id="encountersTable"
                                                    value="#{procedureSender.encounterFilter.getEncounterFiltered()}"
                                                    var="enc" rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                                    render="ds">
                                        <ui:include src="/common/encounterColumns.xhtml">
                                            <ui:param name="encounter" value="#{enc}"/>
                                            <ui:param name="displayPatientInfo" value="true"/>
                                            <ui:param name="extendedTable" value="false"/>
                                        </ui:include>
                                        <g:column>
                                            <ui:define name="header">#{messages['users.Action']}</ui:define>
                                            <a4j:commandLink title="#{messages['gazelle.ordermanager.Select']}"
                                                             actionListener="#{procedureSender.selectEncounter(enc)}"
                                                             render="newOrderDiv">
                                                <span class="gzl-icon-medkit"/>
                                            </a4j:commandLink>
                                        </g:column>
                                        <f:facet name="footer">
                                            <ui:include src="/util/datatableFooter.xhtml">
                                                <ui:param name="dataScrollerId" value="ds"/>
                                                <ui:param name="dataTableId" value="encountersTable"/>
                                            </ui:include>
                                        </f:facet>
                                    </rich:dataTable>
                                </s:div><!-- Select an existing patient -->
                                <s:div id="patientSelection"
                                       rendered="#{procedureSender.selectionType == 'PATIENT'}">
                                    <f:subview id="patFilterView">
                                        <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                                            <ui:define name="filter_buttons">
                                                <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                                 render="patientSelection">
                                                    <span class="gzl-icon-refresh"/>
                                                </a4j:commandLink>
                                                <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                                 actionListener="#{procedureSender.patientFilter.reset()}"
                                                                 render="patientSelection">
                                                    <span class="gzl-icon-times-circle"/>
                                                </a4j:commandLink>
                                            </ui:define>
                                            <ui:include src="/common/filtersOnPatient.xhtml">
                                                <ui:param name="formId" value="patientSelection"/>
                                                <ui:param name="filterClass" value="#{procedureSender.patientFilter}"/>
                                            </ui:include>
                                        </ui:decorate>
                                    </f:subview>
                                    <br/><br/>
                                    #{dataTableStateHolder.setDescendingOn('creationDate')}
                                    <rich:dataTable value="#{procedureSender.patientFilter.getPatientsFiltered()}"
                                                    var="pat"
                                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                                    id="patientsTable"
                                                    render="ds">
                                        <ui:include src="/common/patientColumns.xhtml">
                                            <ui:param name="patient" value="#{pat}"/>
                                        </ui:include>
                                        <g:column>
                                            <ui:define name="header">#{messages['users.Action']}</ui:define>
                                            <a4j:commandLink title="#{messages['gazelle.ordermanager.Select']}"
                                                             actionListener="#{procedureSender.createANewEncounterForPatient(pat)}"
                                                             render="newOrderDiv">
                                                <span class="gzl-icon-medkit"/>
                                            </a4j:commandLink>
                                        </g:column>
                                        <f:facet name="footer">
                                            <ui:include src="/util/datatableFooter.xhtml">
                                                <ui:param name="dataScrollerId" value="ds"/>
                                                <ui:param name="dataTableId" value="patientsTable"/>
                                            </ui:include>
                                        </f:facet>
                                    </rich:dataTable>
                                </s:div>
                            </gri:panel><!-- Display informations about selected encounter and patient -->
                            <gri:panel rendered="#{procedureSender.selectedEncounter != null}">
                                <f:facet name="header">#{messages['gazelle.ordermanager.SelectedPatientAndEncounter']}
                                </f:facet>
                                <ui:include src="/common/displayPatientEncounter.xhtml">
                                    <ui:param name="patient" value="#{procedureSender.selectedPatient}"/>
                                    <ui:param name="encounter" value="#{procedureSender.selectedEncounter}"/>
                                </ui:include>
                            </gri:panel><!-- Ask the user to fill out the newly created Order -->
                            <gri:panel pid="editOrderPanel"
                                       rendered="#{procedureSender.selectedEncounter != null and procedureSender.selectedRequestedProcedure == null}">
                                <f:facet name="header">
                                    <h:outputText value="#{messages['gazelle.ordermanager.createNewOrder']}"/>
                                    <span style="width:10px"/>
                                    <a4j:commandLink title="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                                     actionListener="#{procedureSender.fillOrderRandomly()}"
                                                     immediate="true" render="editOrderPanel">
                                        <span class="gzl-icon-random"/>
                                    </a4j:commandLink>
                                </f:facet><!-- fill randomly button -->
                                <ui:include src="/common/fillingOrder.xhtml">
                                    <ui:param name="order" value="#{procedureSender.selectedOrder}"/>
                                </ui:include>
                                <f:facet name="footer">
                                    <a4j:commandButton styleClass="gzl-btn-blue"
                                                       value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                                       actionListener="#{procedureSender.fillOrderRandomly()}"
                                                       immediate="true" render="editOrderPanel"/>
                                    <a4j:commandButton styleClass="gzl-btn-blue"
                                                       value="#{messages['gazelle.ordermanager.CreateTheOrderAndScheduleProcedure']}"
                                                       actionListener="#{procedureSender.scheduleProcedure()}"
                                                       render="newOrderDiv"/>
                                </f:facet>
                            </gri:panel><!-- Display panel to fill the requested procedures -->
                            <gri:panel rendered="#{procedureSender.selectedRequestedProcedure != null}">
                                <f:facet name="header">
                                    #{messages['gazelle.ordermanager.RequestedProcedureToSchedule']}
                                </f:facet>
                                <ui:include src="/common/procedureDetails.xhtml">
                                    <ui:param name="proc" value="#{procedureSender.selectedRequestedProcedure}"/>
                                    <ui:param name="editSPSDates" value="true"/>
                                    <ui:param name="editModality" value="true"/>
                                </ui:include>
                                <f:facet name="footer">
                                    <a4j:commandButton value="#{messages['gazelle.ordermanager.SendMessage']}"
                                                       actionListener="#{procedureSender.sendMessage()}"
                                                       render="globalDiv"
                                                       styleClass="gzl-btn-blue"/>
                                </f:facet>
                            </gri:panel>
                        </s:div><!-- update procedures -->
                        <s:div id="updateProcedureDiv" rendered="#{procedureSender.selectionType == 'PROCEDURE'}">
                            <gri:panel pid="selectProcedurePanel"
                                       rendered="#{procedureSender.selectedRequestedProcedure == null}">
                                <f:facet name="header">#{messages['gazelle.ordermanager.ProcedureSelection']}</f:facet>
                                <f:subview id="procFilterView">
                                    <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                                        <ui:define name="filter_buttons">
                                            <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                             render="selectProcedurePanel">
                                                <span class="gzl-icon-refresh"/>
                                            </a4j:commandLink>
                                            <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                             actionListener="#{procedureSender.procedureFilter.reset()}"
                                                             render="selectProcedurePanel">
                                                <span class="gzl-icon-times-circle"/>
                                            </a4j:commandLink>
                                        </ui:define>
                                        <ui:include src="/common/filtersOnOrder.xhtml">
                                            <ui:param name="filterClass" value="#{procedureSender.procedureFilter}"/>
                                            <ui:param name="formId" value="selectProcedurePanel"/>
                                        </ui:include>
                                    </ui:decorate>
                                </f:subview>
                                <br/><br/>
                                <rich:dataTable id="proceduresTable"
                                                value="#{procedureSender.procedureFilter.getProcedures()}" var="proc"
                                                rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                                render="ds">
                                    <ui:include src="/common/requestedProcedureColumns.xhtml">
                                        <ui:param name="currentProcedure" value="#{proc}"/>
                                        <ui:param name="displayEncounterInfo" value="false"/>
                                    </ui:include>
                                    <g:column>
                                        <ui:define name="header">#{messages['gazelle.HL7Common.Action']}</ui:define>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.CancelOrDiscontinue']}"
                                                         actionListener="#{procedureSender.setSelectedRequestedProcedure(proc)}"
                                                         oncomplete="jq162('#cancelDiscontinueProcedurePanel').modal('show')"
                                                         rendered="#{procedureSender.orderControlCode.equals(procedureSender.CANCEL_OCC)  or procedureSender.orderControlCode.equals(procedureSender.DISCONTINUE_OCC)}"
                                                         render="procUpdateContent, procUpdateBtn">
                                            <span class="gzl-icon-times-circle"/>
                                        </a4j:commandLink>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.Update_2']}"
                                                         actionListener="#{procedureSender.setSelectedRequestedProcedure(proc)}"
                                                         rendered="#{procedureSender.orderControlCode.equals(procedureSender.UPDATE_OCC) or procedureSender.orderControlCode.equals(procedureSender.COMPLETE)}"
                                                         render="updateProcedureDiv">
                                            <span class="gzl-icon-refresh"/>
                                        </a4j:commandLink>
                                    </g:column>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="ds"/>
                                            <ui:param name="dataTableId" value="proceduresTable"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </gri:panel>
                            <gri:panel id="updateProcedureAttributesDiv"
                                       rendered="#{(procedureSender.orderControlCode.equals(procedureSender.UPDATE_OCC)   or procedureSender.orderControlCode.equals(procedureSender.COMPLETE))              and procedureSender.selectedRequestedProcedure != null}">
                                <f:facet name="header">#{messages['gazelle.ordermanager.UpdateProcedure']}</f:facet>
                                <ui:include src="/common/procedureDetails.xhtml">
                                    <ui:param name="proc" value="#{procedureSender.selectedRequestedProcedure}"/>
                                    <ui:param name="editSPSDates" value="true"/>
                                </ui:include>
                                <f:facet name="footer">
                                    <a4j:commandButton
                                            value="#{messages['gazelle.ordermanager.ChooseAnotherProcedure']}"
                                            actionListener="#{procedureSender.setSelectedRequestedProcedure(null)}"
                                            render="updateProcedureDiv" styleClass="gzl-btn-orange"/>
                                    <a4j:commandButton value="#{messages['gazelle.ordermanager.SendMessage']}"
                                                       actionListener="#{procedureSender.sendMessage()}"
                                                       render="globalDiv" styleClass="gzl-btn-blue"/>
                                </f:facet>
                            </gri:panel>
                        </s:div>
                    </s:div><!-- Exchange messages -->
                    <s:div id="hl7MessagesDiv">
                        <gri:panel rendered="#{procedureSender.hl7Messages != null}">
                            <f:facet name="header">#{messages['gazelle.ordermanager.TestReport']}</f:facet>
                            <ui:include src="/messages/message_table.xhtml">
                                <ui:param name="hl7Messages" value="#{procedureSender.hl7Messages}"/>
                            </ui:include>
                            <f:facet name="footer">
                                <a4j:commandButton value="#{messages['gazelle.ordermanager.PerformAnotherTest']}"
                                                   actionListener="#{procedureSender.setHl7Messages(null)}"
                                                   render="globalDiv" styleClass="gzl-btn-blue"/>
                            </f:facet>
                        </gri:panel>
                    </s:div>
                </gri:panel>
            </s:div>
            <ui:include src="/hl7Initiators/cancelDiscontinueProcedurePanel.xhtml">
                <ui:param name="managedBean" value="#{procedureSender}"/>
            </ui:include>
        </h:form>
    </ui:define>
</ui:composition>
